/**
 * @file mirror/pre_registered/default.hpp
 * @brief Pre-registration of the default set of namespace, types,
 *  classes, etc. with Mirror
 *
 *  Copyright 2008-2010 Matus Chochlik. Distributed under the Boost
 *  Software License, Version 1.0. (See accompanying file
 *  LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
 */

#ifndef MIRROR_PRE_REGISTERED_DEFAULT_1012140609_HPP
#define MIRROR_PRE_REGISTERED_DEFAULT_1012140609_HPP

// namespaces
#include <mirror/pre_registered/namespace/std.hpp>
#include <mirror/pre_registered/namespace/boost.hpp>
#include <mirror/pre_registered/namespace/mirror.hpp>
// Native C/C++ types
#include <mirror/pre_registered/type/native.hpp>
// std::basic_string's
#include <mirror/pre_registered/type/std/string.hpp>
// std::pair template
#include <mirror/pre_registered/type/std/pair.hpp>
// std::tuple template
#include <mirror/pre_registered/type/std/tuple.hpp>
//
#include <mirror/pre_registered/type/std/initializer_list.hpp>
#include <mirror/pre_registered/type/std/allocator.hpp>
#include <mirror/pre_registered/type/std/memory.hpp>
#include <mirror/pre_registered/type/std/functional.hpp>
#include <mirror/pre_registered/type/std/vector.hpp>
#include <mirror/pre_registered/type/std/list.hpp>
#include <mirror/pre_registered/type/std/deque.hpp>
#include <mirror/pre_registered/type/std/map.hpp>
#include <mirror/pre_registered/type/std/set.hpp>
//
// std::tm structure
#include <mirror/pre_registered/class/std/tm.hpp>

#endif //include guard

